include_guard(GLOBAL)

set(CMAKE_SYSTEM_NAME QNX)
set(CMAKE_SYSTEM_PROCESSOR arm)

if (NOT DEFINED CMAKE_FIND_ROOT_PATH_MODE_PROGRAM)
    set(CMAKE_FIND_ROOT_PATH_MODE_PROGRAM NEVER)
endif()
if (NOT DEFINED CMAKE_FIND_ROOT_PATH_MODE_LIBRARY)
    set(CMAKE_FIND_ROOT_PATH_MODE_LIBRARY ONLY)
endif()
if (NOT DEFINED CMAKE_FIND_ROOT_PATH_MODE_PACKAGE)
    set(CMAKE_FIND_ROOT_PATH_MODE_PACKAGE ONLY)
endif()
if (NOT DEFINED CMAKE_FIND_ROOT_PATH_MODE_INCLUDE)
    set(CMAKE_FIND_ROOT_PATH_MODE_INCLUDE ONLY)
endif()

set(arch "ntoarmv7")
set(ver "4.8.3")

find_program(gcc_executable NAMES "${arch}-gcc-${ver}" "${arch}-gcc-${ver}.exe" PATHS ENV QNX_HOST PATH_SUFFIXES "usr/bin" NO_DEFAULT_PATH REQUIRED)
find_program(g++_executable NAMES "${arch}-g++-${ver}" "${arch}-g++-${ver}.exe" PATHS ENV QNX_HOST PATH_SUFFIXES "usr/bin" NO_DEFAULT_PATH REQUIRED)

set(CMAKE_SYSROOT "$ENV{QNX_TARGET}")

string(APPEND CMAKE_C_FLAGS_INIT " -fPIC ")
string(APPEND CMAKE_CXX_FLAGS_INIT " -fPIC ")

set(CMAKE_C_COMPILER "${gcc_executable}")
set(CMAKE_C_COMPILER_TARGET ${arch})

set(CMAKE_CXX_COMPILER "${g++_executable}")
set(CMAKE_CXX_COMPILER_TARGET ${arch})

unset(arch)
unset(ver)
